import type { CloudAssembly } from '@aws-cdk/cx-api';
import type { ICloudAssemblySource } from '../types';
/**
 * A CloudAssemblySource that is caching its result once produced.
 *
 * Most Toolkit interactions should use a cached source.
 * Not caching is relevant when the source changes frequently
 * and it is to expensive to predict if the source has changed.
 */
export declare class CachedCloudAssemblySource implements ICloudAssemblySource {
    private source;
    private cloudAssembly;
    constructor(source: ICloudAssemblySource);
    produce(): Promise<CloudAssembly>;
}
