import type { IIoHost } from '../';
/**
 * An IoHost wrapper that strips out ANSI colors and styles from the message before
 * sending the message to the given IoHost
 */
export declare function withoutColor(ioHost: IIoHost): IIoHost;
/**
 * An IoHost wrapper that strips out emojis from the message before
 * sending the message to the given IoHost
 */
export declare function withoutEmojis(ioHost: IIoHost): IIoHost;
/**
 * An IoHost wrapper that trims whitespace at the beginning and end of messages.
 * This is required, since after removing emojis and ANSI colors,
 * we might end up with floating whitespace at either end.
 */
export declare function withTrimmedWhitespace(ioHost: IIoHost): IIoHost;
